<?php

namespace App\Services\Part;

use App\Entities\Equipment\ServerPartEntity;
use App\Entities\Part\CPUEntity;
use App\Forms\Part\CPUForm;
use App\Helpers\Part\CPUHelper;
use App\Models\Part\CPUModel;
use RuntimeException;

class CPUService extends PartType1Service
{
    protected string $formClass = CPUForm::class;
    protected string $helperClass = CPUHelper::class;

    public function __construct(CPUModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('CPU');
    }
    public function getEntityClass(): string
    {
        return CPUEntity::class;
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): CPUEntity
    {
        return $entity;
    }
    //List 검색용
    //FormFilter 조건절 처리
    //검색어조건절처리
    //OrderBy 처리
    public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->model->orderBy('title ASC');
        parent::setOrderBy($field, $value);
    }
    //서버파트관련 작업
    //파트정보가져오기
    public function getPartEntityByServerPart(ServerPartEntity $serverPartEntity): CPUEntity
    {
        //IP정보에서 해당하는 IP가 있으면 가져와서 사용중인지 체크 후 수정
        $entity = $this->getEntity($serverPartEntity->getPartUid());
        if (!$entity instanceof CPUEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverPartEntity->getPartUid()}에 해당하는 CPUEntity정보를 찾을수없습니다.");
        }
        return $entity;
    }
}
